/* Tabela RECEPADR: Receita Padro */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RECEPADR */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Receita Padro,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_RECEPADR
AFTER DELETE OR INSERT OR UPDATE
ON RECEPADR FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_CDARVPROD VARCHAR2(20);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDARVPROD := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      IF (NVL(:OLD.CDAPRERECE, '') <> '') THEN
         V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE;
      END IF;
      V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODPRAT, 5), '9999999990.00000'));
      IF (NVL(:OLD.SGUNIDADE, '') <> '') THEN
         V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE;
      END IF;
      IF (NVL(:OLD.VRPEFATCOCPR, -1) <> -1) THEN
         V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCPR, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.VRPEFATCORPR, -1) <> -1) THEN
         V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORPR, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.HRTEMPPREPPR, '') <> '') THEN
         V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPPR, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPPR, 4, 5);
      END IF;
      IF (NVL(:OLD.QTBRUTAPRUNR, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPRUNR, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTBRUTAPR, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPR, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.IDPRODBASEPR, '') <> '') THEN
         V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASEPR;
      END IF;
      IF (NVL(:OLD.VRPEFATNUTPR, -1) <> -1) THEN
         V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTPR, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.QTCALCNUTRPR, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRPR, 5), '9999999990.00000'));
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||V_CDARVPROD;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPRATO      <> :NEW.CDPRATO     ) OR
            (:OLD.CDPRODUTO    <> :NEW.CDPRODUTO   ) OR
            (:OLD.QTPRODPRAT   <> :NEW.QTPRODPRAT  ) OR
            (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) OR
            (NVL(:OLD.CDAPRERECE,   '') <> NVL(:NEW.CDAPRERECE,   '')) OR
            (NVL(:OLD.SGUNIDADE,    '') <> NVL(:NEW.SGUNIDADE,    '')) OR
            (NVL(:OLD.VRPEFATCOCPR,  -1) <> NVL(:NEW.VRPEFATCOCPR,  -1)) OR
            (NVL(:OLD.VRPEFATCORPR,  -1) <> NVL(:NEW.VRPEFATCORPR,  -1)) OR
            (NVL(:OLD.HRTEMPPREPPR, '') <> NVL(:NEW.HRTEMPPREPPR, '')) OR
            (NVL(:OLD.QTBRUTAPRUNR,  -1) <> NVL(:NEW.QTBRUTAPRUNR,  -1)) OR
            (NVL(:OLD.QTBRUTAPR,     -1) <> NVL(:NEW.QTBRUTAPR,     -1)) OR
            (NVL(:OLD.IDPRODBASEPR, '') <> NVL(:NEW.IDPRODBASEPR, '')) OR
            (NVL(:OLD.VRPEFATNUTPR,  -1) <> NVL(:NEW.VRPEFATNUTPR,  -1)) OR
            (NVL(:OLD.QTCALCNUTRPR,  -1) <> NVL(:NEW.QTCALCNUTRPR,  -1)) THEN
            V_TIPO   := '2';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||V_CDARVPROD;
         END IF;
      ELSE
         V_TIPO   := '1';
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_ITPESQ := :NEW.CDPRATO||:NEW.CDFILAUXPRAT||V_CDARVPROD;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRATO <> :NEW.CDPRATO) OR (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
            IF (:OLD.CDPRATO <> :NEW.CDPRATO) THEN
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || '|' || :NEW.CDPRATO || ' - ';
            ELSE
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ';
            END IF;
            IF (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT || '|' || :NEW.CDFILAUXPRAT;
            ELSE
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT;
            END IF; 
         ELSE
            V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Prato=' || :NEW.CDPRATO || ' - ' || :NEW.CDFILAUXPRAT;
      END IF; 
      IF UPDATING THEN
         IF (:OLD.CDPRODUTO <> :NEW.CDPRODUTO) THEN
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
            V_DESC := V_DESC || '|' || V_CDARVPROD;
         ELSE
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      ELSE
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF (NVL(:NEW.CDAPRERECE, '') <> '') OR (UPDATING AND (NVL(:NEW.CDAPRERECE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDAPRERECE, '') <> NVL(:NEW.CDAPRERECE, '')) THEN
               V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE || '|' || :NEW.CDAPRERECE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Apres=' || :NEW.CDAPRERECE;
         END IF;
      END IF;
      IF UPDATING THEN
         IF (:OLD.QTPRODPRAT <> :NEW.QTPRODPRAT) THEN
            V_DESC := V_DESC || ' Qtde.=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODPRAT, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODPRAT, 5), '9999999990.00000'));
         END IF;
      ELSE
         V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODPRAT, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:NEW.SGUNIDADE, '') <> '') OR (UPDATING AND (NVL(:NEW.SGUNIDADE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.SGUNIDADE, '') <> NVL(:NEW.SGUNIDADE, '')) THEN
               V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE || '|' || :NEW.SGUNIDADE;
            END IF;
         ELSE 
            V_DESC := V_DESC || ' Un=' || :NEW.SGUNIDADE;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCOCPR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCOCPR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATCOCPR, -1) <> NVL(:NEW.VRPEFATCOCPR, -1)) THEN
               V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCPR, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCPR, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCPR, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCORPR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCORPR, -1) = -1)) THEN
         IF UPDATING THEN
             IF (NVL(:OLD.VRPEFATCORPR, -1) <> NVL(:NEW.VRPEFATCORPR, -1)) THEN  
                V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORPR, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORPR, 5), '9999999990.00'));
             END IF;
         ELSE
            V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORPR, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.HRTEMPPREPPR, '') <> '') OR (UPDATING AND (NVL(:NEW.HRTEMPPREPPR, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.HRTEMPPREPPR, '') <> NVL(:NEW.HRTEMPPREPPR, '')) THEN  
               IF (NVL(:OLD.HRTEMPPREPPR, '') = '') THEN
                  V_DESC := V_DESC || ' Temp=' || '|' || SUBSTR(:NEW.HRTEMPPREPPR, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPPR, 4, 5); 
               ELSE
                  V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPPR, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPPR, 4, 5) || '|' || SUBSTR(:NEW.HRTEMPPREPPR, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPPR, 4, 5);
               END IF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Temp=' || SUBSTR(:NEW.HRTEMPPREPPR, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPPR, 4, 5);
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTAPRUNR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTAPRUNR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTAPRUNR, -1) <> NVL(:NEW.QTBRUTAPRUNR, -1)) THEN  
               V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPRUNR, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPRUNR, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPRUNR, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTAPR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTAPR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTAPR, -1) <> NVL(:NEW.QTBRUTAPR, -1)) THEN  
               V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPR, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPR, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPR, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.IDPRODBASEPR, '') <> '') OR (UPDATING AND (NVL(:NEW.IDPRODBASEPR, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDPRODBASEPR, '') <> NVL(:NEW.IDPRODBASEPR, '')) THEN
               V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASEPR || '|' || :NEW.IDPRODBASEPR;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PrBase=' || :NEW.IDPRODBASEPR;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATNUTPR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATNUTPR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATNUTPR, -1) <> NVL(:NEW.VRPEFATNUTPR, -1)) THEN  
               V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTPR, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTPR, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTPR, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTCALCNUTRPR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTCALCNUTRPR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTCALCNUTRPR, -1) <> NVL(:NEW.QTCALCNUTRPR, -1)) THEN
               V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRPR, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRPR, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRPR, 5), '9999999990.00000'));
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('RECEPADR', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR);
         END IF;
      END IF;
   END IF;
END;
/

